////////////////////////////////////////////////////////////////////////////////
//
// (C) 2010 Sarah Eris Horsley Caffee
//
// mandelbrot - A simple Mandelbrot Set viewer.
//
// Fractal.h
// Fractal calculator virtual class definition.  Actual fractals should 
// implement this.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef FRACTAL_H
#define FRACTAL_H

#include <string>

class Fractal
   {
   public:
   Fractal();

   virtual bool calc_set() = 0;
   virtual bool init(SDL_Surface * surf) = 0;
   void set_re_min(const double r_min);
   void set_im_max(const double i_max);
   void set_size(const double s);
   void set_max_iter(const unsigned int iter);
   void inc_max_iter();
   void dec_max_iter();
   void set_calc_needed();

   double get_re_min();
   double get_im_max();
   double get_size();
   unsigned int get_max_iter();
   const char * get_name();


   protected:

   virtual void draw_pixel(int x, int y, Uint32 * color);

   std::string name;
   double re_min;
   double im_max;
   double size;
   unsigned int max_iter;
   bool calc_needed;

   SDL_Surface * surface;


   };

#endif
