////////////////////////////////////////////////////////////////////////////////
//
// (C) 2010 Sarah Eris Horsley Caffee
//
// mandelbrot - A simple Mandelbrot Set viewer.
//
// Julia.h
// Julia set calculator class definition
//
////////////////////////////////////////////////////////////////////////////////

#ifndef JULIA_H
#define JULIA_H

#include <string>

#include "SDL.h"

#include "Fractal.h"

class Julia : public Fractal
   {
   public:
   Julia();

   bool calc_set();
   bool init(SDL_Surface * surf);

   void get_k(double & re, double & im);
   void set_k(double re, double im);

   private:

   void draw_pixel(int x, int y, Uint32 * color);
   void set_name();

   double k_re;
   double k_im;
   };

#endif
